<?
  include ("../../../admin/config/cfg.php");
  global $cwlang, $cwLanguage;
 	sajax_init();

  //================ PAGE LOGIC ================
  if (count($_POST)>0) {
    $data=$_POST["dep"];
    $entry=Array(
      "name" => $data["name"],
      "shortcut" => $data["shortcut"],
      "inkey" => $data["inkey"],
      "peer" => Array
          (
              "name" => $data["name"],
              "context" => $_POST["right"]  
          ),
      "exten"   => Array(),
      "groups"  => $_POST["group"] 
    );

    //modify mode or insert mode??
    if ($data["id"]!="") $entry["id"]=$data["id"];

    if (is_array($_POST["phonenumber"])) {
      foreach($_POST["phonenumber"] as $pn) {
        $entry["exten"][]=array(                        
            "exten" => $pn,
            "priority" => 1,
            "type" => IAX_DEP_EXTENSION  //IAX_DEP_NUMBER
        );
      }
    }
    if ($data["shortcut"]!="") {
      $entry["exten"][]=array(                        
          "exten" => $data["shortcut"],
          "priority" => 1,
          "type" => IAX_DEP_NICKNAME  //IAX_DEP_SHORTCUT
      );
      $entry["exten"][]=array(                        
          "exten" => $data["shortcut"],
          "priority" => 1,
          "type" => IAX_DEP_NICKNAME2  //IAX_DEP_SHORTCUT
      );
    }

    //advanced option
    if ($data["host"]!="") $entry["peer"]["host"]=$data["host"];
    if ($data["mask"]!="") $entry["peer"]["mask"]=$data["mask"];
    if ($data["username"]!="") $entry["peer"]["username"]=$data["username"];
    if ($data["defaultip"]!="") $entry["peer"]["defaultip"]=$data["defaultip"]; 
    if ($data["amaflags"]!="") $entry["peer"]["amaflags"]=$data["amaflags"]; 
    if ($data["canreinvite"]!="") $entry["peer"]["canreinvite"]=$data["canreinvite"]; 
    if ($data["dtmfmode"]!="") $entry["peer"]["dtmfmode"]=$data["dtmfmode"]; 
    if ($data["language"]!="") $entry["peer"]["language"]=$data["language"]; 
    if ($data["mailbox"]!="") $entry["peer"]["mailbox"]=$data["mailbox"]; 
    if ($data["nat"]!="") $entry["peer"]["nat"]=$data["nat"]; 
    if ($data["deny"]!="") $entry["peer"]["deny"]=$data["deny"]; 
    if ($data["permit"]!="") $entry["peer"]["permit"]=$data["permit"]; 
    if ($data["qualify"]!="") $entry["peer"]["qualify"]=$data["qualify"]; 
    if ($_POST["clientAllow"]!="") $entry["peer"]["allow"]=$_POST["clientAllow"]; 
    $entry["peer"]["friend"]="friend";
    $entry["peer"]["disallow"]="all";
    $entry["peer"]["callgroup"]="1";
    $entry["peer"]["pickupgroup"]="1";
    
    //echo "<pre>"; print_r($entry); die;
    $ret=$asterisk->putDepartment($entry);
    if ($ret>0) {
      $alert="<div class=\"AlertGood\">".$cwlang["dept"]["alertModGood"]."</div>";
      $_GET["id"]=$ret;
    } else $alert="<div class=\"AlertBad\">".$cwlang["dept"]["alertModBad"]."</div>";
    goToMainPage($alert);
  }
  
  //get the department informations
  if (isset($_GET["id"]) and $_GET["id"]!="") {
    $id=$_GET["id"];
    $ret=$asterisk->getDepartment($id);
    if ($err=$asterisk->getError()) die("Error: $err");
  
    $v=$ret[0];
    $id=$v["id"];
    $name=$v["peer"]["name"];
    $host=$v["peer"]["host"];
    $mask=$v["peer"]["mask"];
    $username=$v["peer"]["username"];
    $inkey=$v["inkey"];
    $groups=$v["groups"];
    $protocol=$v["peer"]["protocol"];
    $rights=$v["peer"]["context"];
    $prot="<img src=\"$relBasePath/public/img/iax.gif\" alt=\"iax\" />";

    //advanced Options
    $defaultIp=$v["peer"]["defaultip"];
    $amaflags=$v["peer"]["amaflags"];
    $canreinvite=$v["peer"]["canreinvite"];
    $dtmfmode=$v["peer"]["dtmfmode"];
    $language=$v["peer"]["language"];
    $mailbox=$v["peer"]["mailbox"];
    $nat=$v["peer"]["nat"];
    $deny=$v["peer"]["deny"];
    $permit=$v["peer"]["permit"];
    $qualify=$v["peer"]["qualify"];
    $codecs=$v["peer"]["allow"];
    
    //check if exists the alias extension and create the phone number list
    $alias=false;
    if (is_array($v["exten"])) {
      foreach($v["exten"] as $e) {
        if (!@in_array($e["exten"],$numberFound)) {
          if ($e["type"]==IAX_DEP_EXTENSION) $numbers.="<option value='".$e["exten"]."'>".$e["exten"]."</option>";
          if ($e["type"]==IAX_DEP_NICKNAME) $shortcut=$e["exten"];
          $numberFound[]=$e["exten"];
        }
      }
    }  
    $title=$cwlang["dept"]["modDeptTitle"];
  } else $title=$cwlang["dept"]["newDeptTitle"];
  //================ MAIN CONTENTS ================
  ob_start();
  ?>
  <div class="SectionHeader">
  <?=$alert?>
    <h1><?=$title?></h1>
    <h3>
      <a href="../" class="admin" ><?=$cwlang["dept"]["return"]?></a> 
    </h3>
  </div>
  
  <div id="basic_form">
    <form action="<?=$PHP_SELF?><?if ($_GET["id"]!="") echo "?id=".$_GET["id"]; ?>" method="post" onSubmit="return selectAll(getElementById('phonenumber'))">

    	<h2><?=$cwlang["dept"]["personalInfos"]?></h2>
      <p class="blockintro"><?=$cwlang["dept"]["personalInfosDesc"]?></p>
      <div class="block">
        <dl>
          <dt class="required"><label for="dep[name]"><?=$cwlang["dept"]["name"]?>:</label></dt>
          <dd><input type="text" size="25" maxlength="30" id="dep[name]" name="dep[name]" value="<?=$name?>" /></dd>
          <dt class="required"><label for="dep[host]"><?=$cwlang["dept"]["hostname"]?>:</label></dt> 
          <dd><input type="text" size="25" maxlength="50" id="dep[host]" name="dep[host]" value="<?=$host?>" /> <?=$cwlang["dept"]["hostnameHelp"]?></dd>
          <dt class="required"><label for="dep[mask]"><?=$cwlang["dept"]["mask"]?>:</label></dt>
          <dd><input type="text" size="25" maxlength="100" id="dep[mask]" name="dep[mask]" value="<?=$mask?>" /> <?=$cwlang["dept"]["maskHelp"]?> </dd>
          <dt class="required"><label for="dep[username]"><?=$cwlang["dept"]["username"]?>:</label></dt>
          <dd><input type="text" size="25" maxlength="100" id="dep[username]" name="dep[username]" value="<?=$username?>" /> <?=$cwlang["dept"]["usernameHelp"]?> </dd>
        </dl>
      </div>

      <p class="blockintro"><?=$cwlang["dept"]["rsaKeyDesc"]?></p>
      <div class="block">
        <dl>
          <dt class="required"><label for="dep[inkey]"><?=$cwlang["dept"]["rsaKey"]?>:</label></dt>
          <dd><textarea cols="65" id="dep[inkey]" name="dep[inkey]"  /><?=$inkey?></textarea></dd>
        </dl>
      </div>
      
    	<h2><?=$cwlang["dept"]["phoneNumberTitle"]?></h2>
      <p class="blockintro"><?=$cwlang["dept"]["phoneNumberDesc"]?></p>
      <div class="block">
        <table>
          <tr>
            <td class="required"><label for="number"><?=$cwlang["dept"]["phoneNumber"]?>:</label></td>
            <td class="required"><?=$cwlang["dept"]["phoneNumberAdded"]?></td>
          </tr>
          <tr>
            <td valign="top">
              <input type="text" size="25" maxlength="100" id="number" name="number" value="" />
              <input type="button" value="+" onclick="addOption(getElementById('phonenumber'),document.getElementById('number').value)" title="Add Length">
            </td>
            <td>
              <select name="phonenumber[]" size="4" onchange="saved = false" ondblclick="editOptions(this)" multiple style="float: left" id="phonenumber">
                <?=$numbers?>
              </select>
              <input type="button" value="edit" onclick="editOptions(getElementById('phonenumber'))" title="Edit Length(s)">
              <input type="button" value="X" onclick="deleteOptions(getElementById('phonenumber'))" title="Delete Length(s)">
            </td>
          </tr>
          <tr><td class="required" colspan="2"><label for="number"><?=$cwlang["dept"]["shortcut"]?>:</label></td></tr>
          <tr><td colspan="2"><input type="text" size="25" maxlength="100" id="shortcut" name="dep[shortcut]" value="<?=$v["shortcut"]?>" />
              <?=$cwlang["dept"]["shortcutHelp"]?>
          </td></tr>
        </table>
      </div>

<?    echo listGroup(GROUP_OF_DEPARTMENT, $js, $groups);?>      
<?    echo listRight($js, $rights);?>      

    	<h2><?=$cwlang["dept"]["advancedOptionTitle"]?></h2>
      <p class="blockintro"><?=$cwlang["dept"]["advancedOptionDesc"]?></p>
      <div class="block">
        <input type="checkbox" id="dep[chkadvanced]" name="dep[chkadvanced]" value="1" onclick="this.checked?show('advanced_options'):hide('advanced_options');" /> 
        <label for="dep[chkadvanced]"><?=$cwlang["dept"]["advancedOptionShow"]?></label>
        <div id="advanced_options" style="display: none">
          <table class="todolist">
            <tr>
              <td class="label"><?=$cwlang["dept"]["defaultIp"]?>:</td>
              <td>
                <input type="text" id="dep[defaultip]" name="dep[defaultip]" value="<?=$defaultIp?>"/> <?=$cwlang["dept"]["defaultIpHelp"]?>
              </td>
            </tr>
            <tr>
              <td class="label"><?=$cwlang["dept"]["report"]?>:</td>
              <td>
                <select name="dep[amaflags]" >
                  <option value="default" <? if ($amaflags=="default") echo "selected=\"selected\""; ?> > <?=$cwlang["dept"]["default"]?> </option>
                  <option value="omit" <? if ($amaflags=="omit") echo "selected=\"selected\""; ?> > <?=$cwlang["dept"]["omit"]?> </option>
                  <option value="billing" <? if ($amaflags=="billing") echo "selected=\"selected\""; ?> > <?=$cwlang["dept"]["billing"]?></option>
                  <option value="documentation" <? if ($amaflags=="documentation") echo "selected=\"selected\""; ?> > <?=$cwlang["dept"]["documentation"]?></option>
                </select>
              </td>
            </tr>
            <tr>
              <td class="label"><?=$cwlang["dept"]["canReinvite"]?>?:</td>
              <td>
                <input type="radio" id="dep[canreinvite]" name="dep[canreinvite]" value="no" <? if ($canreinvite!="yes") echo "checked=\"checked\""; ?>/> <?=$cwlang["dept"]["noDefault"]?>
                <input type="radio" id="dep[canreinvite]" name="dep[canreinvite]" value="yes" <? if ($canreinvite=="yes") echo "checked=\"checked\""; ?>/> <?=$cwlang["dept"]["Yes"]?> <?=$canreinvite?>
                <?=$cwlang["dept"]["canReinviteHelp"]?>
              </td>
            </tr>
            <tr>
              <td class="label"><?=$cwlang["dept"]["dtmfMode"]?>:</td>
              <td>
                <select name="dep[dtmfmode]">
                  <option value="rfc2833" <? if ($dtmfmode=="rfc2833") echo "selected=\"selected\""; ?>>RFC2833 (default)</option>
                  <option value="inband" <? if ($dtmfmode=="inband") echo "selected=\"selected\""; ?>>INBAND</option>
                  <option value="info" <? if ($dtmfmode=="info") echo "selected=\"selected\""; ?>>INFO</option>
                </select>
                <?=$cwlang["dept"]["dtmfModeHelp"]?>
              </td>
            </tr>
            <tr>
              <td class="label"><?=$cwlang["dept"]["language"]?>:</td>
              <td>
                <input type="text" id="dep[language]" name="dep[language]" value="<?=$language?>" /> <?=$cwlang["dept"]["languageHelp"]?>
              </td>
            </tr>
            <tr>
              <td class="label"><?=$cwlang["dept"]["mailbox"]?>:</td>
              <td>
                <input type="text" id="dep[mailbox]" name="dep[mailbox]"  value="<?=$mailbox?>"/> <?=$cwlang["dept"]["mailboxDesc"]?>
              </td>
            </tr>
            <tr>
              <td class="label"><?=$cwlang["dept"]["nat"]?>?:</td>
              <td>
                <input type="radio" id="dep[nat]" name="dep[nat]" value="no" <? if ($nat!="yes") echo "checked=\"checked\""; ?> /> <?=$cwlang["dept"]["noDefault"]?>
                <input type="radio" id="dep[nat]" name="dep[nat]" value="yes"  <? if ($nat=="yes") echo "checked=\"checked\""; ?> /> <?=$cwlang["dept"]["yes"]?>
              </td>
            </tr>
            <tr>
              <td class="label"><?=$cwlang["dept"]["denyIp"]?>:</td>
              <td>
                <input type="text" id="dep[deny]" name="dep[deny]" value="<?=$deny?>" /> <?=$cwlang["dept"]["denyIpHelp"]?><br />
              </td>
            </tr>
            <tr>
              <td class="label"><?=$cwlang["dept"]["allowIp"]?>:</td>
              <td>
                <input type="text" id="dep[permit]" name="dep[permit]"  value="<?=$permit?>" /> <?=$cwlang["dept"]["allowIpHelp"]?><br />
              </td>
            </tr>
            <tr>
              <td class="label"><?=$cwlang["dept"]["qualify"]?>?:</td>
              <td>
                <input type="radio" id="dep[qualify]" name="dep[qualify]" value="no" <? if ($qualify!="yes") echo "checked=\"checked\""; ?>/> <?=$cwlang["dept"]["noDefault"]?>
                <input type="radio" id="dep[qualify]" name="dep[qualify]" value="yes" <? if ($qualify=="yes") echo "checked=\"checked\""; ?>/> <?=$cwlang["dept"]["yes"]?>
                <?=$cwlang["dept"]["qualifyHelp"]?>
              </td>
            </tr>
            <tr>
              <td class="label"><?=$cwlang["dept"]["codecs"]?>:</td>
              <td>
                <select name="selectCodec">
                  <option value="g729">g729</option>
                  <option value="speex">speex</option>
                  <option value="gsm">gsm</option>
                  <option value="ilbc">ilbc</option>
                  <option value="alaw">alaw</option>
                  <option value="ulaw">ulaw</option>
                </select>
                <input type="button" value="<?=$cwlang["dept"]["codecsAdd"]?>" onClick="concatSelect(this.form.selectCodec,this.form.clientAllow)">
                <input type="text" name="clientAllow" size="50" value="<?=$codecs?>">
              </td>
            </tr>

          </table> 
        </div>    
      </div>
    
  
    <div class="action">
      <?if ($_GET["id"]!="") {?><input type="hidden" name="dep[id]" value="<?=$id?>" /><?}?>
      <input type="image" src="<?=$relBasePath?>/public/img/<?=$cwLanguage?>/b-cancel.gif" alt="Annulla" onclick="location.href='../'; return false;"/>
      <input type="image" src="<?=$relBasePath?>/public/img/<?=$cwLanguage?>/b-save.gif" alt="Salva" />
    </div>
  </form>
 </div>  
  
  <?
  $contents=ob_get_contents();
  ob_end_clean();

  //================ SIDEBAR ================
  ob_start(); 
  ?>
        <div class="Sidebar">
          <h1><?=$cwlang["dept"]["sidebarEditTitle"]?></h1>
          <?=$cwlang["dept"]["sidebarEditText"]?>
        </div>
  <?  
  $sidebar=ob_get_contents();
  ob_end_clean();

  //================ SETTINGS ================
 	sajax_handle_client_request();

  $smarty->assign("section", "departments");
  $smarty->assign("subsection", "");
  $smarty->assign("templateType", "TwoColLeft");  //OneCol, TwoColLeft, TwoColRight
  $smarty->assign("contents", $contents);
  $smarty->assign("sidebar", $sidebar);
  $smarty->assign("ajax", $js);
  $smarty->display('settings.tpl');
?>

